Index: c/src/lib/libbsp/arm/gumstix/ChangeLog
===================================================================
--- c/src/lib/libbsp/arm/gumstix/ChangeLog	(revision 336d67ac1711f4c53fc567a343cd28bcfc1843d3)
+++ c/src/lib/libbsp/arm/gumstix/ChangeLog	(revision 0d833168cca1f3fbad5b51ed0016498c28b22cf4)
@@ -1,2 +1,8 @@
+2010-04-30	Sebastian Huber <sebastian.huber@embedded-brains.de>
+
+	* Makefile.am, preinstall.am: Added generic interrupt support modules.
+	* include/bsp.h: Define BSP_FEATURE_IRQ_EXTENSION.
+	* startup/bspstart.c, rtl8019/rtl8019.c: Interrupt support changes.
+
 2010-04-30	Sebastian Huber <sebastian.huber@embedded-brains.de>
 
Index: c/src/lib/libbsp/arm/gumstix/Makefile.am
===================================================================
--- c/src/lib/libbsp/arm/gumstix/Makefile.am	(revision 336d67ac1711f4c53fc567a343cd28bcfc1843d3)
+++ c/src/lib/libbsp/arm/gumstix/Makefile.am	(revision 0d833168cca1f3fbad5b51ed0016498c28b22cf4)
@@ -14,4 +14,6 @@
 include_HEADERS = include/bsp.h
 include_HEADERS += include/tm27.h
+
+include_bsp_HEADERS =
 
 nodist_include_HEADERS = include/bspopts.h
@@ -39,4 +41,12 @@
 #console
 libbsp_a_SOURCES += console/uarts.c ../../shared/console.c
+# IRQ
+include_bsp_HEADERS += ../../shared/include/irq-generic.h \
+	../../shared/include/irq-info.h
+libbsp_a_SOURCES += ../../shared/src/irq-generic.c \
+	../../shared/src/irq-legacy.c \
+	../../shared/src/irq-info.c \
+	../../shared/src/irq-shell.c \
+	../../shared/src/irq-server.c
 #abort
 libbsp_a_SOURCES += ../shared/abort/abort.c
Index: c/src/lib/libbsp/arm/gumstix/include/bsp.h
===================================================================
--- c/src/lib/libbsp/arm/gumstix/include/bsp.h	(revision 336d67ac1711f4c53fc567a343cd28bcfc1843d3)
+++ c/src/lib/libbsp/arm/gumstix/include/bsp.h	(revision 0d833168cca1f3fbad5b51ed0016498c28b22cf4)
@@ -22,4 +22,6 @@
 #include <rtems/clockdrv.h>
 #include <libchip/serial.h>
+
+#define BSP_FEATURE_IRQ_EXTENSION
 
 #define BSP_HAS_FRAME_BUFFER 1
Index: c/src/lib/libbsp/arm/gumstix/preinstall.am
===================================================================
--- c/src/lib/libbsp/arm/gumstix/preinstall.am	(revision 336d67ac1711f4c53fc567a343cd28bcfc1843d3)
+++ c/src/lib/libbsp/arm/gumstix/preinstall.am	(revision 0d833168cca1f3fbad5b51ed0016498c28b22cf4)
@@ -66,4 +66,12 @@
 PREINSTALL_FILES += $(PROJECT_LIB)/linkcmds
 
+$(PROJECT_INCLUDE)/bsp/irq-generic.h: ../../shared/include/irq-generic.h $(PROJECT_INCLUDE)/bsp/$(dirstamp)
+	$(INSTALL_DATA) $< $(PROJECT_INCLUDE)/bsp/irq-generic.h
+PREINSTALL_FILES += $(PROJECT_INCLUDE)/bsp/irq-generic.h
+
+$(PROJECT_INCLUDE)/bsp/irq-info.h: ../../shared/include/irq-info.h $(PROJECT_INCLUDE)/bsp/$(dirstamp)
+	$(INSTALL_DATA) $< $(PROJECT_INCLUDE)/bsp/irq-info.h
+PREINSTALL_FILES += $(PROJECT_INCLUDE)/bsp/irq-info.h
+
 if ON_SKYEYE
 endif
Index: c/src/lib/libbsp/arm/gumstix/rtl8019/rtl8019.c
===================================================================
--- c/src/lib/libbsp/arm/gumstix/rtl8019/rtl8019.c	(revision 336d67ac1711f4c53fc567a343cd28bcfc1843d3)
+++ c/src/lib/libbsp/arm/gumstix/rtl8019/rtl8019.c	(revision 0d833168cca1f3fbad5b51ed0016498c28b22cf4)
@@ -12,5 +12,5 @@
 
 #include <bsp.h>
-#include <irq.h>
+#include <bsp/irq.h>
 #include "wd80x3.h"
 
Index: c/src/lib/libbsp/arm/gumstix/startup/bspstart.c
===================================================================
--- c/src/lib/libbsp/arm/gumstix/startup/bspstart.c	(revision 336d67ac1711f4c53fc567a343cd28bcfc1843d3)
+++ c/src/lib/libbsp/arm/gumstix/startup/bspstart.c	(revision 0d833168cca1f3fbad5b51ed0016498c28b22cf4)
@@ -10,4 +10,5 @@
 
 #include <bsp.h>
+#include <bsp/irq-generic.h>
 #include <rtems/libcsupport.h>
 #include <rtems/libio.h>
@@ -16,5 +17,4 @@
 /* Function prototypes */
 void rtems_exception_init_mngt(void);
-void  rtems_irq_mngt_init(void);
 
 /*
@@ -37,5 +37,7 @@
   XSCALE_INT_ICMR = 0x0;
   rtems_exception_init_mngt();
-  rtems_irq_mngt_init();
+  if (bsp_interrupt_initialize() != RTEMS_SUCCESSFUL) {
+    _CPU_Fatal_halt(0xe);
+  }
 } /* bsp_start */
 
